"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MySqlConnection = void 0;
const MySqlSqlBuilder_1 = require("../sqlBuilders/MySqlSqlBuilder");
const AbstractMySqlMariaDBConnection_1 = require("./AbstractMySqlMariaDBConnection");
class MySqlConnection extends AbstractMySqlMariaDBConnection_1.AbstractMySqlMariaDBConnection {
    constructor(queryRunner, sqlBuilder = new MySqlSqlBuilder_1.MySqlSqlBuilder()) {
        super(queryRunner, sqlBuilder);
        this.uuidStrategy = 'binary';
        /**
         * The compatibility mode try to maximize the compatibility with older versions of MySQL (MySQL 5)
         *
         * The syntax avoided are:
         * - With clause, instead the query is directly included in the from
         *
         * Note: Recursive queries are not supported
         */
        this.compatibilityMode = false;
        queryRunner.useDatabase('mySql');
    }
}
exports.MySqlConnection = MySqlConnection;
