"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OracleConnection = void 0;
const OracleSqlBuilder_1 = require("../sqlBuilders/OracleSqlBuilder");
const AbstractAdvancedConnection_1 = require("./AbstractAdvancedConnection");
class OracleConnection extends AbstractAdvancedConnection_1.AbstractAdvancedConnection {
    constructor(queryRunner, sqlBuilder = new OracleSqlBuilder_1.OracleSqlBuilder()) {
        super(queryRunner, sqlBuilder);
        this.uuidStrategy = 'custom-functions';
        queryRunner.useDatabase('oracle');
    }
    transformValueToDB(value, type) {
        if (type === 'boolean' && typeof value === 'boolean') {
            // https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number#number_coercion
            return Number(value);
        }
        return super.transformValueToDB(value, type);
    }
}
exports.OracleConnection = OracleConnection;
